%define xfree86_version 4.3.0-16.EL

Summary:   A remote display system.
Name:      vnc
Version:   4.0
Release:   0.beta4.1.1
URL:       http://www.realvnc.com
Source0:   http://www.realvnc.com/dist/vnc-4.0b4-unixsrc.tar.gz
Source1:   http://www.realvnc.com/dist/vnc-4.0b4-javasrc.tar.gz
# This is from 'rpmbuild -bp XFree86.spec':
Source2:   XFree86-%{xfree86_version}.tar.bz2
Source3:   vncserver.init
Source4:   gen-javaviewer.sh
Source5:   vnc-4.0b4-javabytecompiled.tar.bz2
Patch0:    vnc-cookie.patch
Patch1:    vnc-fPIC.patch
Patch2:    vnc-compat.patch
Patch3:    vnc-xclients.patch
Patch4:    vnc-idle.patch
Patch5:    vnc-via.patch
License:   GPL
Group:     User Interface/Desktops
BuildRoot: %{_tmppath}/%{name}-%{version}-root
BuildPrereq: /usr/bin/perl tcp_wrappers
BuildRequires: zlib-devel libjpeg-devel XFree86-devel
BuildRequires: desktop-file-utils >= 0.2.92
Prereq:    /sbin/chkconfig /sbin/service

%description
Virtual Network Computing (VNC) is a remote display system which
allows you to view a computing 'desktop' environment not only on the
machine where it is running, but from anywhere on the Internet and
from a wide variety of machine architectures.  This package contains a
client which will allow you to connect to other desktops running a VNC
server.

%package server
Summary: A VNC server.
Requires: bash >= 2.0, /usr/bin/mcookie
Group: User Interface/X
Prereq: /sbin/chkconfig /etc/init.d

%description server
The VNC system allows you to access the same desktop from a wide
variety of platforms.  This package is a VNC server, allowing others
to access the desktop on your machine.

%prep
%setup -q -n vnc-4.0b4-unixsrc -a1 -a5
bzip2 -dc %{SOURCE2} | tar -xkf - || :
%patch0 -p1 -b .cookie
%patch1 -p1 -b .fPIC
%patch2 -p1 -b .compat
%patch3 -p1 -b .xclients
%patch4 -p1 -b .idle
%patch5 -p1 -b .via

# Apply the patch from the VNC tarball.
patch -p0 -i xc.patch

rm -rf java

%build
%configure --with-installed-zlib
make

cd xc
make CDEBUGFLAGS="$RPM_OPT_FLAGS" World FAST=1

%install
rm -rf %{buildroot}

bin=%{buildroot}%{_bindir}
man=%{buildroot}%{_mandir}
ext=%{buildroot}/usr/X11R6/%{_lib}/modules/extensions
mkdir -p $bin $man $man/man1 $ext
./vncinstall $bin $man $ext
chmod u+w $bin/* $ext/* || :

mkdir -p %{buildroot}%{_datadir}/vnc/classes
cp -aR unix/java/* %{buildroot}%{_datadir}/vnc/classes

mkdir -p %{buildroot}/etc/rc.d/init.d
install -m755 %{SOURCE3} %{buildroot}/etc/rc.d/init.d/vncserver

mkdir -p %{buildroot}/etc/sysconfig
cat > %{buildroot}/etc/sysconfig/vncservers << EOF
# The VNCSERVERS variable is a list of display:user pairs.
#
# Uncomment the line below to start a VNC server on display :1
# as my 'myusername' (adjust this to your own).  You will also
# need to set a VNC password; run 'man vncpasswd' to see how
# to do that.  
#
# DO NOT RUN THIS SERVICE if your local area network is
# untrusted!  For a secure way of using VNC, see
# <URL:http://www.uk.research.att.com/vnc/sshvnc.html>.

# VNCSERVERS="1:myusername"
EOF
chmod 644 %{buildroot}/etc/sysconfig/vncservers

mkdir -p %{buildroot}/etc/X11/applnk/Applications
cat > vncviewer.desktop << EOF
[Desktop Entry]
Encoding=UTF-8
Name=VNC Viewer
Comment=VNC client application
Exec=/usr/bin/vncviewer
Terminal=false
Type=Application
StartupWMClass=vncviewer
EOF
# Desktop file installation.
mkdir $RPM_BUILD_ROOT%{_datadir}/applications
desktop-file-install --vendor vnc --delete-original    \
  --dir $RPM_BUILD_ROOT%{_datadir}/applications        \
  --add-category X-Red-Hat-Extra                       \
  --add-category Utility                               \
  --add-category Application                           \
  vncviewer.desktop

%clean
rm -rf %{buildroot}

%post server
if [ "$1" = 1 ]; then
  /sbin/chkconfig --add vncserver
fi

%preun server
if [ "$1" = 0 ]; then
  /sbin/service vncserver stop >/dev/null 2>&1
  /sbin/chkconfig --del vncserver
fi

%postun server
if [ "$1" -ge "1" ]; then
  /sbin/service vncserver condrestart >/dev/null 2>&1
fi

%files
%defattr(-,root,root)
%doc LICENCE.TXT README 
%{_bindir}/vncviewer
%{_datadir}/applications/*
%{_mandir}/man1/vncviewer.1*

%files server
%defattr(-,root,root)
%attr(0755,root,root) %config /etc/rc.d/init.d/vncserver
%config(noreplace) /etc/sysconfig/vncservers
%{_bindir}/Xvnc
%{_bindir}/vncpasswd
%{_bindir}/vncconfig
%{_bindir}/vncserver
%{_bindir}/x0vncserver
%{_datadir}/vnc
%{_mandir}/man1/Xvnc.1*
%{_mandir}/man1/vncpasswd.1*
%{_mandir}/man1/vncconfig.1*
%{_mandir}/man1/vncserver.1*
%{_mandir}/man1/x0vncserver.1*
/usr/X11R6

%changelog
* Fri Sep  5 2003 Tim Waugh <twaugh@redhat.com> 4.0-0.beta4.1.1
- 4.0beta4.
- No longer need compile, dotvnc, norender, vncpasswdq patches.
- Don't be so picky about which architectures to build on.
- Build requires XFree86-devel.

* Thu Aug 28 2003 Tim Waugh <twaugh@redhat.com> 4.0-0.beta3.5.5
- Actually apply IdleTimeout patch.
- SSH tunnelling support (bug #102213).

* Wed Aug 20 2003 Tim Waugh <twaugh@redhat.com> 4.0-0.beta3.5.4
- Disable IdleTimeout by default.

* Mon Aug 18 2003 Tim Waugh <twaugh@redhat.com> 4.0-0.beta3.5.3
- Fix compilation (bug #102547).
- Fix vncpasswd (bug #102435).

* Tue Aug 12 2003 Tim Waugh <twaugh@redhat.com> 4.0-0.beta3.5.2
- Use patched tarball from XFree86 package.
- Build Java VNC viewer.

* Wed Aug  6 2003 Tim Waugh <twaugh@redhat.com> 4.0-0.beta3.5.1
- Rebuilt.

* Wed Aug  6 2003 Tim Waugh <twaugh@redhat.com> 4.0-0.beta3.5
- Make default xclients file include instructions for 'normal' desktop.
- Server subpackage doesn't require XFree86.
- desktop file: add StartupWMClass tag
- init script: set USER (bug #101674).
- init script: pause when restarting to give the server a chance to stop
  (bug #84817).
- vncpasswd: create ~/.vnc if it doesn't already exist.

* Tue Aug  5 2003 Tim Waugh <twaugh@redhat.com> 4.0-0.beta3.4
- Allow old -dontdisconnect option, and behave a bit more like Xvnc used to
  if it is given (default to no password, use RFB3.3 protocol).
- Fixed DisconnectClients bug.

* Mon Aug  4 2003 Tim Waugh <twaugh@redhat.com> 4.0-0.beta3.3
- Disable RENDER altogether for Xvnc.

* Mon Aug  4 2003 Tim Waugh <twaugh@redhat.com> 4.0-0.beta3.2
- Reinstated init script.
- Add work-around for Xcursor bug.

* Thu Jul 31 2003 Tim Waugh <twaugh@redhat.com> 4.0-0.beta3.1
- Initial package.
